;-------------------------------------------------------------------------------
; coolmenu.as - N[ȃj[\W[
;-------------------------------------------------------------------------------
;
; Copyright(c) 2006,2011 sharkpp All rights reserved.
;
; The MIT License
;
; Permission is hereby granted, free of charge, to any person obtaining a copy
; of this software and associated documentation files (the "Software"), to deal
; in the Software without restriction, including without limitation the rights
; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
; copies of the Software, and to permit persons to whom the Software is
; furnished to do so, subject to the following conditions:
;
; The above copyright notice and this permission notice shall be included in
; all copies or substantial portions of the Software.
;
; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
; OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
; THE SOFTWARE.
;
;*******************************************************************************
; ȉɎQlƂ The MIT License ̓{𕹋L܂AЕzƂẮA
; Lɏ]ĂB
;*******************************************************************************
;
; The MIT License
;
; ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@C
; iȉu\tgEFAvj̕擾邷ׂĂ̐lɑ΂A\tgEFA
; ɈƂ𖳏ŋ܂Bɂ́A\tgEFA̕gpA
; ʁAύXAAfځAЕzATuCZXA/܂͔̔錠A
; у\tgEFA񋟂鑊ɓƂ錠Ɋ܂܂
; ܂B
;
; L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dv
; ȕɋLڂ̂Ƃ܂B
;
; \tgEFÁû܂܁vŁAł邩Öقł邩킸A
; ۏ؂Ȃ񋟂܂Błۏ؂Ƃ́AiA̖ړIւ̓KA
; ьNQɂĂ̕ۏ؂܂݂܂AɌ肳̂ł͂
; ܂B҂܂͒쌠҂́A_sׁAs@sׁA܂͂ȊOł낤
; ƁA\tgEFAɋN܂͊֘AA邢̓\tgEFA̎gp܂͂
; ̈ɂĐ؂̐AQȂ̋`ɂĉ̐ӔC
; Ȃ̂Ƃ܂B 
;
;-------------------------------------------------------------------------------

#include "user32.as"

#ifndef        __COOL_MENU__
#define global __COOL_MENU__

#module _CoolMenu handle, is_menubar, flag, caption, caption_h, caption_h2, caption_v, image_index

#define WM_DRAWITEM					$002B
#define WM_MEASUREITEM				$002C

#define global MF_BYCOMMAND			$0000
#define global MF_BYPOSITION		$0400
#define global MF_UNCHECKED			$0000
#define global MF_HILITE			$0080
#define global MF_UNHILITE			$0000

#define global MF_BITMAP			$0004
#define global MF_CHECKED			$0008
#define global MF_DISABLED			$0002
#define global MF_ENABLED			$0000
#define global MF_GRAYED			$0001
#define global MF_MENUBARBREAK		$0020
#define global MF_MENUBREAK			$0040
#define global MF_OWNERDRAW			$0100
#define global MF_POPUP				$0010
#define global MF_SEPARATOR			$0800
#define global MF_STRING			$0000
#define global MF_DEFAULT			$1000
#define global MF_SYSMENU			$2000
#define global MF_HELP				$4000
#define global MF_END				$0080
#define global MF_RIGHTJUSTIFY		$4000
#define global MF_MOUSESELECT		$8000

#define global MIIM_BITMAP			$0080
#define global MIIM_CHECKMARKS		$0008
#define global MIIM_DATA			$0020
#define global MIIM_FTYPE			$0100
#define global MIIM_ID				$0002
#define global MIIM_STATE			$0001
#define global MIIM_STRING			$0040
#define global MIIM_SUBMENU			$0004
#define global MIIM_TYPE			$0010

#define global MFT_BITMAP			$0004
#define global MFT_MENUBARBREAK		$0020
#define global MFT_MENUBREAK		$0040
#define global MFT_OWNERDRAW		$0100
#define global MFT_RADIOCHECK		$0200
#define global MFT_RIGHTJUSTIFY		$4000
#define global MFT_RIGHTORDER		$2000
#define global MFT_SEPARATOR		$0800
#define global MFT_STRING			$0000

; for WM_DRAWITEM/WM_MEASUREITEM
#define ODT_MENU					1

#define ODA_DRAWENTIRE				1
#define ODA_SELECT					2
#define ODA_FOCUS					4

#define ODS_SELECTED				1
#define ODS_GRAYED					2
#define ODS_DISABLED				4
#define ODS_CHECKED					8
#define ODS_FOCUS					16
#define ODS_DEFAULT					32
; WINVER >= 0x0500
#define ODS_HOTLIGHT				$0040
#define ODS_INACTIVE				$0080
#define ODS_NOACCEL					$0100
#define ODS_NOFOCUSRECT				$0200

; System Menu Command Values
#define SC_SIZE						$F000
#define SC_MOVE						$F010
#define SC_MINIMIZE					$F020
#define SC_MAXIMIZE					$F030
#define SC_NEXTWINDOW				$F040
#define SC_PREVWINDOW				$F050
#define SC_CLOSE					$F060
#define SC_VSCROLL					$F070
#define SC_HSCROLL					$F080
#define SC_MOUSEMENU				$F090
#define SC_KEYMENU					$F100
#define SC_ARRANGE					$F110
#define SC_RESTORE					$F120
#define SC_TASKLIST					$F130
#define SC_SCREENSAVE				$F140
#define SC_HOTKEY					$F150
#define SC_DEFAULT					$F160
#define SC_MONITORPOWER 			$F170
#define SC_CONTEXTHELP				$F180
#define SC_SEPARATOR				$F00F

; DrawText() Format Flags
#define DT_TOP						$00000000
#define DT_LEFT						$00000000
#define DT_CENTER					$00000001
#define DT_RIGHT					$00000002
#define DT_VCENTER					$00000004
#define DT_BOTTOM					$00000008
#define DT_WORDBREAK				$00000010
#define DT_SINGLELINE				$00000020
#define DT_EXPANDTABS				$00000040
#define DT_TABSTOP					$00000080
#define DT_NOCLIP					$00000100
#define DT_EXTERNALLEADING			$00000200
#define DT_CALCRECT					$00000400
#define DT_NOPREFIX					$00000800
#define DT_INTERNAL					$00001000
#define DT_EDITCONTROL				$00002000
#define DT_PATH_ELLIPSIS			$00004000
#define DT_END_ELLIPSIS				$00008000
#define DT_MODIFYSTRING				$00010000
#define DT_RTLREADING				$00020000
#define DT_WORD_ELLIPSIS			$00040000
#define DT_NOFULLWIDTHCHARBREAK		$00080000
#define DT_HIDEPREFIX				$00100000
#define DT_PREFIXONLY				$00200000

; for BitBlt
#define SRCCOPY	   0xCC0020

; for DrawFrameControl
#define DFC_MENU			$00000002
#define DFCS_MENUCHECK		$00000001
#define DFCS_MENUBULLET		$00000002

#uselib "gdi32"
#func BitBlt@_CoolMenu "BitBlt" int,int,int,int,int,int,int,int,int

#uselib "user32"
#func DrawText@_CoolMenu         "DrawTextA"        sptr,sptr,sptr,sptr,sptr
#func DrawFrameControl@_CoolMenu "DrawFrameControl" sptr,sptr,sptr,sptr

#define ICON_SIZE	 	18
#define ITEM_MARGIN	 	 2
#define ICON_MARGIN	 	 4
#define SHORTCUT_MARGIN	10

#define RADIO_SIZE		8

#define MENUBAR_SHADOW	5

#define rect_left	rect
#define rect_top	rect(1)
#define rect_right	rect(2)
#define rect_bottom	rect(3)
#define rect_width	rect(5)
#define rect_height	rect(6)

#define bmscr_divx		(bmscr(83)    >>16)
#define bmscr_divy		(bmscr(83)<<16>>16)
#define bmscr_divsx		(bmscr(84)    >>16)
#define bmscr_divsy		(bmscr(84)<<16>>16)
#define bmscr_celofsx	(bmscr(85)    >>16)
#define bmscr_celofsy	(bmscr(85)<<16>>16)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; typedef struct tagMENUITEMINFO {
#define mii_cbSize        mii(0)    ;   UINT      cbSize;
#define mii_fMask         mii(1)    ;   UINT      fMask;
#define mii_fType         mii(2)    ;   UINT      fType;
#define mii_fState        mii(3)    ;   UINT      fState;
#define mii_wID           mii(4)    ;   UINT      wID;
#define mii_hSubMenu      mii(5)    ;   HMENU     hSubMenu;
#define mii_hbmpChecked   mii(6)    ;   HBITMAP   hbmpChecked;
#define mii_hbmpUnchecked mii(7)    ;   HBITMAP   hbmpUnchecked;
#define mii_dwItemData    mii(8)    ;   ULONG_PTR dwItemData;
#define mii_dwTypeData    mii(9)    ;   LPTSTR    dwTypeData;
#define mii_cch           mii(10)   ;   UINT      cch;
#define mii_hbmpItem      mii(11)   ;   HBITMAP   hbmpItem;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; } MENUITEMINFO, *LPMENUITEMINFO;
#const sizeof_mii 12 * 4

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; typedef struct tagMEASUREITEMSTRUCT {
#define mis_CtlType         mis(0)  ;   UINT      CtlType;
#define mis_CtlID           mis(1)  ;   UINT      CtlID;
#define mis_itemID          mis(2)  ;   UINT      itemID;
#define mis_itemWidth       mis(3)  ;   UINT      itemWidth;
#define mis_itemHeight      mis(4)  ;   UINT      itemHeight;
#define mis_itemData        mis(5)  ;   ULONG_PTR itemData;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; } MEASUREITEMSTRUCT, NEAR PMEASUREITEMSTRUCT, FAR LPMEASUREITEMSTRUCT;
#const sizeof_mis 6 * 4

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; DRAWITEMSTRUCT {
#define dis_CtlType         dis(0)  ;   UINT CtlType
#define dis_CtlID           dis(1)  ;   UINT CtlID;
#define dis_itemID          dis(2)  ;   UINT itemID;
#define dis_itemAction      dis(3)  ;   UINT itemAction;
#define dis_itemState       dis(4)  ;   UINT itemState;
#define dis_hwndItem        dis(5)  ;   HWND hwndItem;
#define dis_hDC             dis(6)  ;   HDC  hDC;
#define dis_rcItem_left     dis(7)  ;   RECT rcItem;
#define dis_rcItem_top      dis(8)  ;
#define dis_rcItem_right    dis(9)  ;
#define dis_rcItem_bottom   dis(10) ;
#define dis_itemData        dis(11) ;   ULONG_PTR itemData;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; }
#const sizeof_dis 12 * 4

;=====================================================================
; ֐E
;=====================================================================

#deffunc CoolMenuInit local _gsel
#ifdef oncmd2
	oncmd gosub *on_wm_drawitem@_CoolMenu,	WM_DRAWITEM
	oncmd gosub *on_wm_measureitem@_CoolMenu,	WM_MEASUREITEM
#endif
	wid_img = -1
	_gsel = ginfo_sel
	wid_buffer = ginfo_newid
	buffer wid_buffer
;	bgscr wid_buffer
	sysfont 17
	dimtype item, 5 ; vartype("struct")
	item_count = 0
	gsel _gsel, 0
	return

#deffunc CoolMenuFree onexit
	item_count = 0
	return

#modfunc local calc_item_size_sub int handle_, var caption_h_, var caption_h2_
	if handle != handle_ {
		return
	}
	if caption_h < caption_h_ {
		caption_h = caption_h_
	} else {
		caption_h_ = caption_h
	}
	if caption_h2 < caption_h2_ {
		caption_h2 = caption_h2_
	} else {
		caption_h2_ = caption_h2
	}
	return

#modfunc local calc_item_size local _gsel, local rect, local tmp
	dim rect, 4
	_gsel = ginfo_sel
	gsel wid_buffer
	getstr tmp, caption, 0, '\t'
	DrawText hdc, tmp, -1, varptr(rect), DT_SINGLELINE|DT_CENTER|DT_VCENTER|DT_CALCRECT
	caption_h = rect_right  - rect_left
	caption_v = rect_bottom - rect_top
	DrawText hdc, strmid(caption, strlen(tmp) + 1, 0xFFFF), -1, varptr(rect), DT_SINGLELINE|DT_CENTER|DT_VCENTER|DT_CALCRECT
	caption_h2 = rect_right - rect_left
	gsel _gsel
	; x̃j[ACe̕XV
	repeat item_count
		calc_item_size_sub@_CoolMenu item(cnt), handle, caption_h, caption_h2
	loop
	return

#modinit int _p1, str _p2, int _p3, int _p4, int _p5
	handle		= _p1
	flag		= _p3
	is_menubar	= _p5
	caption		= _p2
	image_index	= _p4
	calc_item_size@_CoolMenu thismod
	return

#modfunc local measure_office2002like array mis
;logmes strf("mis>>%s", caption)
	if flag & MF_SEPARATOR {
		; Zp[^
		mis_itemWidth  = 0
		mis_itemHeight = 3
		caption_v      = 0
		caption_h      = 0
		caption_h2     = 0
	} else {
		calc_item_size@_CoolMenu thismod
		mis_itemWidth = caption_h + caption_h2
		mis_itemHeight= ICON_SIZE + ITEM_MARGIN * 2
		if 1 != is_menubar {
			mis_itemWidth += ICON_SIZE + ITEM_MARGIN * 2 + ICON_MARGIN
			if caption_h2 {
				mis_itemWidth += SHORTCUT_MARGIN
			}
		}
	}
	return

#modfunc local draw_office2002like array dis, local _dis, local mii, local bmscr, local rect, local rect2, local _gsel, local tmp, local n, local offset, local is_grayed, local is_selected
;logmes strf("dis>>%s", caption)
	if 1 == is_menubar && 0 != (dis_itemAction & ODA_SELECT) {
		; bZ[WċÂŏԂۑ
		_dis = varptr(dis)
		DrawMenubar hwnd
		dupptr dis, _dis, sizeof_dis, 4
	}

	dim rect, 7
	rect(0) = dis_rcItem_left, dis_rcItem_top, dis_rcItem_right, dis_rcItem_bottom
	rect(4) = rect(3) - rect(1) + 1 ; p`ʒu
	rect(5) = rect(2) - rect(0), rect(3) - rect(1)
;	is_grayed	= 
;	is_selected	= 

	if -1 != wid_img {
		mref bmscr, 96 + wid_img
	}

	_gsel = ginfo_sel
	gsel wid_buffer, 0

	if 1 == is_menubar : syscolor 15 : else : syscolor 4
	boxf rect_left, rect_top, rect_right, rect_bottom

	if 1 != is_menubar {
		; ACRE`FbNȂǂ̗̈̑ѕ\
		syscolor 22
		boxf rect_left, rect_top, rect_left + ICON_SIZE + ITEM_MARGIN * 2 - 1, rect_bottom
	} else {
		BitBlt hdc, rect_left + rect_width, rect_top, MENUBAR_SHADOW, rect_height, dis_hDC, rect_left + rect_width, rect_top, SRCCOPY
		; hbvVh[p
		syscolor 21
		boxf rect_left + rect_width, rect_top + rect_height, rect_left + rect_width + MENUBAR_SHADOW, rect_bottom + rect_height
	}

	if flag & MF_SEPARATOR {
		; Zp[^
		rect(4) = rect_top + rect_height / 2
		syscolor 16
		line rect_left + ICON_SIZE + ITEM_MARGIN * 2 + ICON_MARGIN / 2, rect(4), rect_right, rect(4)
	} else {
		; I\
		if 1 == is_menubar {
			if dis_itemState & ODS_HOTLIGHT {
				dis_itemState |= ODS_SELECTED
			} else : if dis_itemState & ODS_SELECTED {
				dis_itemState &= -1 ^ ODS_SELECTED
				syscolor 16
				boxf rect_left, rect_top, rect_right - 1, rect_bottom - 1
				syscolor 22
				boxf rect_left + 1, rect_top + 1, rect_right - 2, rect_bottom - 2 + 1
				; hbvVhE`
				syscolor 21
#const MENUBAR_SHADOW_ MENUBAR_SHADOW/2
				repeat MENUBAR_SHADOW
					gmode 3, , , 5 + cnt * 10
					pos rect_left + rect_width, rect_top + rect_height / 4 + cnt
					gcopy wid_buffer, rect_left + rect_width, rect_top + rect_height, MENUBAR_SHADOW - cnt, rect_height
					pos rect_left + rect_width, rect_top + rect_height / 4
					gcopy wid_buffer, rect_left + rect_width, rect_top + rect_height, MENUBAR_SHADOW - cnt, rect_height
				loop
				n = MENUBAR_SHADOW
			}
		}
		if dis_itemState & ODS_SELECTED {
			offset += 0 == (dis_itemState & ODS_GRAYED)
			syscolor 13
			boxf rect_left, rect_height + rect_top, rect_right, rect_height + rect_bottom
			; g
			if dis_itemState & ODS_GRAYED : gmode 3, 0, 0, 96 : else : gmode 3, 0, 0, 240
			pos rect_left,   rect_top	 : gcopy wid_buffer, rect_left,   rect_height + rect_top,   rect_width,     rect_height
			; h
			syscolor 4
			boxf rect_left+1, rect_top+1, rect_right-2, rect_bottom-2
			if dis_itemState & ODS_GRAYED : gmode 3, 0, 0, 32 : else : gmode 3, 0, 0, 64
			pos rect_left+1, rect_top+1 : gcopy wid_buffer, rect_left+1, rect_height + rect_top+1, rect_width - 2, rect_height - 2
		}
		; DF\
		if dis_itemState & ODS_GRAYED : syscolor 17 : else : syscolor 7

		; 
		if dis_itemState & ODS_DEFAULT : font "MS UI Gothic", 12, 1
		if 1 == is_menubar {
			DrawText hdc, caption, -1, varptr(rect), DT_SINGLELINE|DT_CENTER|DT_VCENTER
		} else {
			rect_left += ICON_SIZE + ITEM_MARGIN * 2 + ICON_MARGIN
			getstr tmp, caption, 0, '\t'
			DrawText hdc, tmp, -1, varptr(rect), DT_SINGLELINE|DT_VCENTER|DT_LEFT
			rect_left += caption_h + SHORTCUT_MARGIN
			tmp = strmid(caption, strlen(tmp) + 1, 0xFFFF)
			DrawText hdc, tmp, -1, varptr(rect), DT_SINGLELINE|DT_VCENTER|DT_LEFT
			rect_left -= ICON_SIZE + ITEM_MARGIN * 2 + ICON_MARGIN + caption_h + SHORTCUT_MARGIN
		}
		if dis_itemState & ODS_DEFAULT : sysfont 17

		; ACRE`FbN
		if 0 == is_menubar {	; `FbN
			if dis_itemState & ODS_CHECKED {
				; ݂̃`FbNԂXV(ʏ`FbNƃWI`FbN̏Ԃ邽)
				dim mii, sizeof_mii
				mii_cbSize = sizeof_mii
				mii_fMask  = MIIM_FTYPE
				GetMenuItemInfo handle, dis_itemID, 0, varptr(mii)
				flag &= MFT_RADIOCHECK ^ -1
				flag |= mii_fType & MFT_RADIOCHECK
				; `
				syscolor 13
				boxf rect_left, rect(4) + rect_top, rect_left + 1 + ICON_SIZE, rect(4) + rect_top + 1 + ICON_SIZE
				; g
				if dis_itemState & ODS_GRAYED : gmode 3, 0, 0, 96 : else : gmode 3, 0, 0, 240
				pos rect_left+ITEM_MARGIN-1, rect_top+ITEM_MARGIN-1 : gcopy wid_buffer, rect_left,	 rect(4) + rect_top,		ICON_SIZE + 2, ICON_SIZE + 2
				; h
				if 1 == is_menubar : syscolor 15 : else : syscolor 4
				boxf rect_left+ITEM_MARGIN,  rect_top+ITEM_MARGIN, rect_left+ITEM_MARGIN+ICON_SIZE-1, rect_top+ITEM_MARGIN+ICON_SIZE-1
				if dis_itemState & ODS_GRAYED : gmode 3, 0, 0, 32 : else : gmode 3, 0, 0, 96
				pos rect_left+ITEM_MARGIN,   rect_top+ITEM_MARGIN	 : gcopy wid_buffer, rect_left + 2, rect(4) + rect_top + 2, ICON_SIZE,	   ICON_SIZE
				;
			;	rect_left -= offset
			;	rect_top  -= offset
				if -1 == wid_img || -1 == image_index {
;					; ہE`FbN
;					if flag & MFT_RADIOCHECK {	  ; 
;	#const RADIO_OFFSET (ICON_SIZE-RADIO_SIZE)/2
;						syscolor 18
;						circle rect_left+ITEM_MARGIN+RADIO_OFFSET, rect_top+ITEM_MARGIN+RADIO_OFFSET, rect_left+ITEM_MARGIN+RADIO_OFFSET+RADIO_SIZE-1, rect_top+ITEM_MARGIN+RADIO_OFFSET+RADIO_SIZE-1
;					} else {	; `FbN
;						; Ƃ肠
;					;	font "Wingdings", ICON_SIZE * 9 / 10
;					;	syscolor 20
;					;	pos rect_left+ITEM_MARGIN+2+1, rect_top+ITEM_MARGIN+2+1 : mes strf("%c", 0xFC)
;					;	syscolor 18
;					;	pos rect_left+ITEM_MARGIN+2, rect_top+ITEM_MARGIN+2 : mes strf("%c", 0xFC)
;					;	sysfont 17
;					}
					rect2 = rect_left+ITEM_MARGIN+1, rect_top+rect_height+ITEM_MARGIN, rect_left+ITEM_MARGIN+ICON_SIZE+1, rect_top+rect_height+ITEM_MARGIN+ICON_SIZE
					if flag & MFT_RADIOCHECK {
						DrawFrameControl hdc, varptr(rect2), DFC_MENU, DFCS_MENUBULLET 
					} else {
						DrawFrameControl hdc, varptr(rect2), DFC_MENU, DFCS_MENUCHECK 
					}
					pget rect2, rect2(1)
					gmode 4, ICON_SIZE-1, ICON_SIZE, 256
					pos rect2, rect2(1) - rect_height
					gcopy wid_buffer, rect2, rect2(1)
				}
			;	rect_left += offset
			;	rect_top  += offset
			}
			if -1 != wid_img && -1 != image_index {	; ACR
				color
				pos rect_left + ITEM_MARGIN - offset + (ICON_SIZE - bmscr_divsx) / 2, rect_top + ITEM_MARGIN - offset + (ICON_SIZE - bmscr_divsy) / 2
				gmode 4, , , 256 - (0 != (dis_itemState & ODS_GRAYED)) * 128
				celput wid_img, image_index
			}
		} else:if 2 == is_menubar {
			; VXej[p̃V{`
			if dis_itemState & ODS_GRAYED : syscolor 17 : else : syscolor 18
			pos rect_left+ITEM_MARGIN, rect_top
			switch dis_itemID
				case SC_MINIMIZE: font "Webdings", 14, 16 : mes strf("%c", 0x30) : swbreak
				case SC_MAXIMIZE: font "Webdings", 14, 16 : mes strf("%c", 0x31) : swbreak
				case SC_RESTORE:  font "Webdings", 14, 16 : mes strf("%c", 0x32) : swbreak
				case SC_CLOSE:    font "Webdings", 16, 16 : mes strf("%c", 0x72) : swbreak
			swend
			sysfont 17
		}
	}

	BitBlt dis_hDC, rect_left, rect_top, rect_width + n, rect_height, hdc, rect_left, rect_top, SRCCOPY
	gsel _gsel, 0
	return

*on_wm_measureitem@_CoolMenu
	dupptr mis_, lparam, sizeof_mis, 4 ; vartype("int")
;logmes "----- " + (0 <= mis_(5) && mis_(5) < item_count)
;repeat sizeof_mis / 4
;logmes strf("dis(%d)=%d", cnt, mis_(cnt))
;loop
	if 0 <= mis_(5) && mis_(5) < item_count {
		measure_office2002like@_CoolMenu item(mis_(5)), mis_
		return 1
	}
	return

*on_wm_drawitem@_CoolMenu
	dupptr dis_, lparam, sizeof_dis, 4 ; vartype("int")
;logmes "----- " + (0 <= dis_(11) && dis_(11) < item_count)
;repeat sizeof_dis / 4
;logmes strf("dis(%d)=%d", cnt, dis_(cnt))
;loop
	if 0 <= dis_(11) && dis_(11) < item_count {
		draw_office2002like@_CoolMenu item(dis_(11)), dis_
		return 1
	}
	return

;=====================================================================
; J֐E
;=====================================================================

#define global CoolMenuRelayMessage \
	     if WM_DRAWITEM@_CoolMenu    == iparam { dupptr dis_@_CoolMenu, lparam, sizeof_dis@_CoolMenu, 4 : if ODT_MENU@_CoolMenu == dis_@_CoolMenu { goto *on_wm_drawitem@_CoolMenu    } } \
	else:if WM_MEASUREITEM@_CoolMenu == iparam { dupptr mis_@_CoolMenu, lparam, sizeof_mis@_CoolMenu, 4 : if ODT_MENU@_CoolMenu == mis_@_CoolMenu { goto *on_wm_measureitem@_CoolMenu } }

#define global InsertMenuOD(%1,%2,%3,%4=-1,%5="",%6=-1)	InsertMenuOD_ %1,%2,%3,%4,%5,%6
#deffunc InsertMenuOD_ int _p1, int _p2, int _p3, int _p4, str _p5, int _p6
	GetMenu hwnd
	newmod item, _CoolMenu, _p1, _p5, _p3, _p6, _p1 == stat
	InsertMenu _p1, _p2, _p3|MF_OWNERDRAW, _p4, item_count
	item_count++
	return

#deffunc CoolMenuApplySystemMenu local hSysMenu, local mii, local tmp
	GetSystemMenu hwnd, 0 : hSysMenu = stat
	GetMenuItemCount hSysMenu
	repeat stat
		sdim tmp, 256
		dim mii, sizeof_mii
		mii_cbSize = sizeof_mii
		mii_fMask  = MIIM_FTYPE|MIIM_STRING|MIIM_STATE
		mii_dwTypeData = varptr(tmp)
		mii_cch    = 255
		GetMenuItemInfo hSysMenu, cnt, 1, varptr(mii)
		mii_fType |= MFT_OWNERDRAW
		mii_fMask  = MIIM_FTYPE|MIIM_DATA
		mii_dwItemData = item_count
		SetMenuItemInfo hSysMenu, cnt, 1, varptr(mii)
		;
		newmod item, _CoolMenu, hSysMenu, tmp, mii_fType, -1, 2
		item_count++
	loop
	return

#deffunc CoolMenuSetImage int imgid_
	wid_img = imgid_
	return

#global

CoolMenuInit

#endif ; __COOL_MENU__

